import { Connection, Keypair, PublicKey } from '@solana/web3.js';
import { DataV2 } from '@metaplex-foundation/mpl-token-metadata';
import * as spl from '@solana/spl-token';
declare type CreateMetadataV2Params = {
    connection: Connection;
    publicKey: PublicKey;
    mint: PublicKey;
    metadataData: DataV2;
    updateAuthority?: PublicKey;
    payer: Keypair;
};
export declare function createMetadataV2({ connection, publicKey, mint, metadataData, updateAuthority, payer, }: CreateMetadataV2Params): Promise<{
    metadata: PublicKey;
    createTxDetails: string;
}>;
export declare function mintAndCreateMetadataV2(connection: Connection, payer: Keypair, args: DataV2): Promise<{
    mint: spl.Token;
    metadata: PublicKey;
}>;
export declare function createMasterEdition(connection: Connection, payer: Keypair, args: DataV2, maxSupply: number): Promise<{
    mint: spl.Token;
    metadata: PublicKey;
    masterEditionPubkey: PublicKey;
    createTxDetails: string;
}>;
export {};
