"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMasterEdition = exports.mintAndCreateMetadataV2 = exports.createMetadataV2 = void 0;
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const bn_js_1 = __importDefault(require("bn.js"));
const spl = __importStar(require("@solana/spl-token"));
async function createMetadataV2({ connection, publicKey, mint, metadataData, updateAuthority, payer, }) {
    const metadata = await mpl_token_metadata_1.deprecated.Metadata.getPDA(mint);
    const createMetadataTx = new mpl_token_metadata_1.deprecated.CreateMetadataV2({ feePayer: publicKey }, {
        metadata,
        metadataData,
        updateAuthority: updateAuthority !== null && updateAuthority !== void 0 ? updateAuthority : publicKey,
        mint: mint,
        mintAuthority: publicKey,
    });
    createMetadataTx.recentBlockhash = (await connection.getRecentBlockhash()).blockhash;
    await createMetadataTx.sign(payer);
    const createTxDetails = await connection.sendRawTransaction(createMetadataTx.serialize(), {
        skipPreflight: false,
    });
    return { metadata, createTxDetails };
}
exports.createMetadataV2 = createMetadataV2;
async function mintAndCreateMetadataV2(connection, payer, args) {
    const mint = await spl.Token.createMint(connection, payer, payer.publicKey, null, 0, spl.TOKEN_PROGRAM_ID);
    const fromTokenAccount = await mint.getOrCreateAssociatedAccountInfo(payer.publicKey);
    await mint.mintTo(fromTokenAccount.address, payer.publicKey, [], 1);
    const initMetadataData = args;
    const { metadata } = await createMetadataV2({
        connection,
        publicKey: payer.publicKey,
        mint: mint.publicKey,
        metadataData: initMetadataData,
        payer,
    });
    return { mint, metadata };
}
exports.mintAndCreateMetadataV2 = mintAndCreateMetadataV2;
async function createMasterEdition(connection, payer, args, maxSupply) {
    const { mint, metadata } = await mintAndCreateMetadataV2(connection, payer, args);
    const masterEditionPubkey = await mpl_token_metadata_1.deprecated.MasterEdition.getPDA(mint.publicKey);
    const createMev3 = new mpl_token_metadata_1.deprecated.CreateMasterEditionV3({ feePayer: payer.publicKey }, {
        edition: masterEditionPubkey,
        metadata: metadata,
        updateAuthority: payer.publicKey,
        mint: mint.publicKey,
        mintAuthority: payer.publicKey,
        maxSupply: new bn_js_1.default(maxSupply),
    });
    createMev3.recentBlockhash = (await connection.getRecentBlockhash()).blockhash;
    await createMev3.sign(payer);
    const createTxDetails = await connection.sendRawTransaction(createMev3.serialize(), {
        skipPreflight: true,
    });
    await connection.confirmTransaction(createTxDetails, connection.commitment);
    return { mint, metadata, masterEditionPubkey, createTxDetails };
}
exports.createMasterEdition = createMasterEdition;
//# sourceMappingURL=metaplex.js.map