import { Fanout, FanoutClient } from '../../src';
import { Keypair, PublicKey } from '@solana/web3.js';
import { Token } from '@solana/spl-token';
declare type BuiltNftFanout = {
    fanout: PublicKey;
    name: string;
    fanoutAccountData: Fanout;
    members: NftFanoutMember[];
};
declare type NftFanoutMember = {
    voucher: PublicKey;
    mint: PublicKey;
    wallet: Keypair;
};
declare type BuiltWalletFanout = {
    fanout: PublicKey;
    name: string;
    fanoutAccountData: Fanout;
    members: WalletFanoutMember[];
};
declare type WalletFanoutMember = {
    voucher: PublicKey;
    wallet: Keypair;
};
declare type StakedMembers = {
    voucher: PublicKey;
    stakeAccount: PublicKey;
    wallet: Keypair;
};
declare type BuiltTokenFanout = {
    fanout: PublicKey;
    name: string;
    membershipMint: Token;
    fanoutAccountData: Fanout;
    members: StakedMembers[];
};
export declare function builtTokenFanout(mint: Token, mintAuth: Keypair, fanoutSdk: FanoutClient, shares: number, numberMembers: number): Promise<BuiltTokenFanout>;
export declare function builtWalletFanout(fanoutSdk: FanoutClient, shares: number, numberMembers: number): Promise<BuiltWalletFanout>;
export declare function builtNftFanout(fanoutSdk: FanoutClient, shares: number, numberMembers: number): Promise<BuiltNftFanout>;
export {};
