import { Provider } from '@project-serum/anchor';
import { PublicKey } from '@solana/web3.js';
export declare class TokenUtils {
    provider: Provider;
    constructor(provider: Provider);
    expectBalance(account: PublicKey, balance: number): Promise<void>;
    expectBalanceWithin(account: PublicKey, balance: number, precision: number): Promise<void>;
    expectAtaBalance(account: PublicKey, mint: PublicKey, balance: number): Promise<void>;
    createWrappedNativeAccount(provider: Provider, amount: number, wallet: PublicKey): Promise<PublicKey>;
    mintTo(mint: PublicKey, amount: number, destination: PublicKey, wallet: PublicKey): Promise<void>;
    sendTokens(provider: Provider, mint: PublicKey, to: PublicKey, amount: number, owner: PublicKey, payer: PublicKey): Promise<PublicKey>;
    createAtaAndMint(provider: Provider, mint: PublicKey, amount: number, to: PublicKey, authority: PublicKey, payer: PublicKey): Promise<PublicKey>;
}
